#!/bin/sh
#
# $Id: build.sh,v 1.8 2004/12/15 18:02:32 gianluca Exp $
#
# Top level script to compile como.
#
# All arguments are passed directly to gmake.
# We suggest:
#	sh build.sh clean		# to clean the tree
#	sh build.sh -s			# to build things
#
if [ `uname` = 'Linux' ]; then
    MAKE=make
elif [ `uname` = 'FreeBSD' ]; then
    # MAKE=/usr/ports/devel/gmake/work/make-3.80/make
    MAKE=gmake
fi

mk=como.gmk	# The Makefile name
# We need to compile the libs first
for file in `find base test modules apps -name ${mk}`
do
	olddir=`pwd`
	cd `dirname $file`
	echo
	echo "--> Working in `pwd`"
	echo
	if ! $MAKE -f ${mk} $@; then
		echo "*** Error in `pwd`:"
		echo "***        make -f ${mk} $@"
		exit
	fi
	cd $olddir
done
echo
echo "--> Success."
