/*
 * $Id: os.h,v 1.3 2005/01/11 12:21:26 gianluca Exp $
 */

/*
 * Here we deal with all os-specific dependencies that can be
 * solved by the compiler.
 */
#ifndef _COMO_OS_H_
#define _COMO_OS_H_

    /***					***/
    /***		Linux			***/
    /***					***/

#ifdef linux

#define _GNU_SOURCE	/* Required to use asprintf in Linux */

/*
 * FreeBSD has __unused defined in the system's header.
 * We redefine it here as we need a shorter form for this anyways.
 */
#define __unused __attribute__((__unused__))

/*
 * MAP_NOSYNC is unavailble in Linux 
 * XXX: beware! This is not a general solution
 */
#define MAP_NOSYNC 0

/*
 * EPROGUNAVAIL is not defined in Linux
 */
#define EPROGUNAVAIL ENOTSUP

/*
 * setproctitle(3) is unavailable in Linux; we provide one here
 * Please call init_setproctitle before calling setproctitle
 * for the first time.
 */
void init_setproctitle (int argc, char** argv);
int setproctitle (const char *fmt, ...);

#endif /* linux */

    /***					***/
    /***		FreeBSD			***/
    /***					***/

#ifdef __FreeBSD__

/*
 * Unclear if there is a portable solution for NAMLEN. In the meantime
 * we use the one used in Linux
 */
#define _D_EXACT_NAMLEN(f) ((f)->d_namlen)

/*
 * ENODATA is not defined in Linux
 */
#define ENODATA EINVAL

#endif /* FreeBSD */

#endif /* _COMO_OS_H_ */
